export declare type TimerType = 'DECREMENTAL' | 'INCREMENTAL';
export interface IConfig {
    endTime: number | null;
    initialTime: number;
    interval: number;
    onTimeOver?: () => void;
    step: number;
    timerType: TimerType;
}
export interface IValues {
    isRunning: boolean;
    pause: () => void;
    reset: () => void;
    start: () => void;
    time: number;
}
export declare const useTimer: (config?: Partial<IConfig> | undefined) => IValues;
