"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var initialConfig = {
    endTime: null,
    initialTime: 0,
    interval: 1000,
    step: 1,
    timerType: 'INCREMENTAL',
};
exports.useTimer = function (config) {
    var _a = __assign(__assign({}, initialConfig), config), endTime = _a.endTime, initialTime = _a.initialTime, interval = _a.interval, onTimeOver = _a.onTimeOver, step = _a.step, timerType = _a.timerType;
    var intervalRef = react_1.useRef(null);
    var pausedTimeRef = react_1.useRef(null);
    var _b = react_1.useState(false), shouldResetTime = _b[0], setShouldResetTime = _b[1];
    var _c = react_1.useState(initialTime), time = _c[0], setTime = _c[1];
    var _d = react_1.useState(false), isRunning = _d[0], setIsRunning = _d[1];
    var cancelInterval = function () {
        if (intervalRef.current) {
            clearInterval(intervalRef.current);
            intervalRef.current = null;
            setIsRunning(false);
        }
    };
    var createInterval = function () {
        setIsRunning(true);
        intervalRef.current = setInterval(function () {
            setTime(function (previousTime) {
                var newTime = timerType === 'INCREMENTAL'
                    ? previousTime + step
                    : previousTime - step;
                if (endTime !== null && newTime === endTime) {
                    stopTimerWhenTimeIsOver();
                }
                return newTime;
            });
        }, interval);
    };
    var pause = function () {
        pausedTimeRef.current = time;
        cancelInterval();
    };
    var reset = function () {
        pausedTimeRef.current = null;
        cancelInterval();
        resetTime();
    };
    var resetTime = function () {
        setTime(initialTime);
    };
    var start = function () {
        if (intervalRef.current) {
            return;
        }
        if (shouldResetTime) {
            resetTime();
            setShouldResetTime(false);
        }
        createInterval();
    };
    var stopTimerWhenTimeIsOver = function () {
        cancelInterval();
        setShouldResetTime(true);
        if (typeof onTimeOver === 'function') {
            onTimeOver();
        }
    };
    react_1.useEffect(function () { return cancelInterval; }, []);
    return { isRunning: isRunning, pause: pause, reset: reset, start: start, time: time };
};
